/*
 * The MIT License
 *
 * Copyright 2013 Dra0211.
 *
 * Permission is hereby granted, free of charge, to any person obtaining a copy
 * of this software and associated documentation files (the "Software"), to deal
 * in the Software without restriction, including without limitation the rights
 * to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
 * copies of the Software, and to permit persons to whom the Software is
 * furnished to do so, subject to the following conditions:
 *
 * The above copyright notice and this permission notice shall be included in
 * all copies or substantial portions of the Software.
 *
 * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
 * IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
 * FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
 * AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
 * LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
 * OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN
 * THE SOFTWARE.
 */
package kinugasa.contents.text;

import java.io.File;
import java.io.PrintStream;
import java.io.Serializable;
import java.util.ArrayList;
import java.util.Arrays;
import java.util.Collection;
import java.util.Iterator;
import kinugasa.contents.resource.Nameable;
import kinugasa.util.annotations.CallSuper;
import kinugasa.util.annotations.CallTiming;
import kinugasa.util.annotations.CastReturnValue;
import kinugasa.util.annotations.VirtualMethod;

/**
 * テキストファイルの入出力の共通機能を定義します.
 * <br>
 * TextIOの名前は、ファイルからパスを除いたファイル名が使用されます。<br>
 * たとえば、hoge/piyo/fuga.txtならfuga.txtです。<br>
 * <br>
 * TextIOのデータを操作するメソッドは、thisインスタンスを戻すことによって
 * 局所的な利便性を高めています。全てのTextIOの実装は、これらのメソッドを
 * 適切にオーバーライドし、thisを戻す必要があります。<br>
 *
 * @param <T> テキストファイルのある1行の内容を表すクラスを指定します。
 *            たとえば、CSVファイルではString[]です。<br>
 *
 * @version 1.0.0 - 2013/01/13_19:51:24<br>
 * @author Dra0211<br>
 */
public abstract class TextIO<T> implements Iterable<T>, Nameable, Serializable {

	private static final long serialVersionUID = -4706947051077791206L;
	/** このテキストデータのファイルインスタンスです. */
	protected final File file;
	/** データの内容を表すリストです.
	 * データのインデックスは、テキストデータの行に対応します。<br>
	 */
	protected final ArrayList<T> data;

	/**
	 * ファイル名を指定して、テキストファイルを構築します.
	 * 通常は、コンストラクタをコールしただけではデータの読み込みや
	 * ファイルの作成は行われません。<br>
	 *
	 * @param filePath ファイルパスを指定します。<br>
	 */
	public TextIO(String filePath) {
		this(new File(filePath));
	}

	/**
	 * ファイルを指定して、テキストファイルを構築します.
	 * 通常は、コンストラクタをコールしただけではデータの読み込みや
	 * ファイルの作成は行われません。<br>
	 *
	 * @param file ファイルを指定します。<br>
	 */
	public TextIO(File file) {
		this.file = file;
		data = new ArrayList<T>(32);
	}

	/**
	 * テキストファイルの内容に対応した、データを取得します.
	 *
	 * @return ファイルの内容を返します。リストのインデックスが、行番号に対応しています。<br>
	 */
	public final ArrayList<T> getData() {
		return data;
	}

	/**
	 * データの最初の値を返します。
	 *
	 * @return データの0番目の要素を返します。データが1つもない場合はnullを返します。<br>
	 */
	public final T getFirst() {
		return data.isEmpty() ? null : data.get(0);
	}

	/**
	 * ファイルインスタンスを取得します.
	 *
	 * @return ファイルインスタンスを返します。<br>
	 */
	public final File getFile() {
		return file;
	}

	/**
	 * 要素をこのテキストファイルの末尾に追加します.
	 * このメソッドは、TextIOのすべての実装でオーバーライドし、super.add()をコールする必要があります。
	 *
	 * @param obj 追加するオブジェクトを指定します。<br>
	 *
	 * @return thisインスタンスを返します。<br>
	 */
	@VirtualMethod
	@CallSuper(CallTiming.ANY)
	@CastReturnValue
	public TextIO<T> add(T obj) {
		data.add(obj);
		return this;
	}

	/**
	 * 要素をこのテキストファイルの末尾に追加します.
	 * このメソッドは、TextIOのすべての実装でオーバーライドし、super.add()をコールする必要があります。
	 *
	 * @param obj 追加するオブジェクトを指定します。<br>
	 *
	 * @return thisインスタンスを返します。<br>
	 */
	@VirtualMethod
	@CallSuper(CallTiming.ANY)
	@CastReturnValue
	public TextIO<T> add(T... obj) {
		data.addAll(Arrays.asList(obj));
		return this;
	}

	/**
	 * 要素をこのテキストファイルの末尾に追加します.
	 * このメソッドは、TextIOのすべての実装でオーバーライドし、super.add()をコールする必要があります。
	 *
	 * @param obj 追加するオブジェクトを指定します。<br>
	 *
	 * @return thisインスタンスを返します。<br>
	 */
	@VirtualMethod
	@CallSuper(CallTiming.ANY)
	@CastReturnValue
	public TextIO<T> add(Collection<? extends T> obj) {
		data.addAll(data);
		return this;
	}

	/**
	 * 他のTextIOのすべての要素を、このテキストファイルの末尾に追加します.
	 * このメソッドは、読み込み用TextIOからロードしたデータを書き込み用TextIOに発行する場合に有用です。<br>
	 * このメソッドは、TextIOのすべての実装でオーバーライドし、super.add()をコールする必要があります。
	 *
	 * @param other 追加するオブジェクトが含まれたTextIOを指定します。<br>
	 *
	 * @return thisインスタンスを返します。<br>
	 */
	@VirtualMethod
	@CallSuper(CallTiming.ANY)
	@CastReturnValue
	public TextIO<T> add(TextIO<? extends T> other) {
		add(other.data);
		return this;
	}

	/**
	 * 要素をこのテキストファイルから削除します.
	 * このメソッドは、TextIOのすべての実装でオーバーライドし、super.remove()をコールする必要があります。
	 *
	 * @param obj 削除するオブジェクトを指定します。<br>
	 *
	 * @return thisインスタンスを返します。<br>
	 */
	@VirtualMethod
	@CallSuper(CallTiming.ANY)
	@CastReturnValue
	public TextIO<T> remove(T obj) {
		data.remove(obj);
		return this;
	}

	/**
	 * 要素をこのテキストファイルから削除します.
	 * このメソッドは、TextIOのすべての実装でオーバーライドし、super.remove()をコールする必要があります。
	 *
	 * @param obj 削除するオブジェクトを指定します。<br>
	 *
	 * @return thisインスタンスを返します。<br>
	 */
	@VirtualMethod
	@CallSuper(CallTiming.ANY)
	@CastReturnValue
	public TextIO<T> remove(T... obj) {
		data.removeAll(Arrays.asList(obj));
		return this;
	}

	/**
	 * 要素をこのテキストファイルから削除します.
	 * このメソッドは、TextIOのすべての実装でオーバーライドし、super.remove()をコールする必要があります。
	 *
	 * @param obj 削除するオブジェクトを指定します。<br>
	 *
	 * @return thisインスタンスを返します。<br>
	 */
	@VirtualMethod
	@CallSuper(CallTiming.ANY)
	@CastReturnValue
	public TextIO<T> remove(Collection<? extends T> obj) {
		data.removeAll(data);
		return this;
	}

	/**
	 * 他のTextIOのすべての要素を、このテキストファイルから削除します.
	 * このメソッドは、読み込み用TextIOからロードしたデータを書き込み用TextIOに発行する場合に有用です。<br>
	 * このメソッドは、TextIOのすべての実装でオーバーライドし、super.remove()をコールする必要があります。
	 *
	 * @param other 削除するオブジェクトが含まれたTextIOを指定します。<br>
	 *
	 * @return thisインスタンスを返します。<br>
	 */
	@VirtualMethod
	@CallSuper(CallTiming.ANY)
	@CastReturnValue
	public TextIO<T> remove(TextIO<? extends T> other) {
		remove(other.data);
		return this;
	}

	/**
	 * 全ての要素を破棄します.
	 *
	 * @return thisインスタンスを返します。<br>
	 */
	@VirtualMethod
	@CallSuper(CallTiming.ANY)
	@CastReturnValue
	public TextIO<T> clear() {
		data.clear();
		return this;
	}

	/**
	 * 現時点での行数を取得します.
	 *
	 * @return このテキストデータの行数を返します。dataの要素数です。<br>
	 */
	public final int size() {
		return data.size();
	}

	/**
	 * データが1件も追加されていない場合に、trueを返します.
	 *
	 * @return dataのisEmptyを返します。<br>
	 */
	public final boolean isEmpty() {
		return data.isEmpty();
	}

	@Override
	public String toString() {
		return "TextIO{" + "file=" + file + ", data=" + data + '}';
	}

	/**
	 * 追加されているすべての要素のtoStringをストリームに発行します.
	 * このメソッドはデバッグ用です。<br>
	 *
	 * @param stream 発行するストリームを指定します。<br>
	 */
	public void printAll(PrintStream stream) {
		stream.println("> TextIO : " + this);
		for (T obj : this) {
			stream.println(obj);
		}
		stream.println("> TextIO : ------------------------");
	}

	@Override
	public Iterator<T> iterator() {
		return data.iterator();
	}

	@Override
	public final String getName() {
		return file.getName();
	}
}
